<template>
	<div id="app">
		<div>
			<v-file-input multiple label="File input" v-model="files" @change="onFileSelected"></v-file-input>
		</div>
		<div>
			<v-app id="inspire">
				<v-row justify="center">
					<v-dialog
						v-model="dialogTableJob"
						fullscreen
						hide-overlay
						transition="dialog-bottom-transition"
						persistent
					>
						<v-card>
							<v-toolbar dark color="grey lighten-1">
								<v-btn
									icon
									dark
									@click="
                                        (dialogTableJob = false), (files = [])
                                    "
								>
									<v-icon>mdi-close</v-icon>
								</v-btn>
								<v-toolbar-title>Settings</v-toolbar-title>
								<v-spacer></v-spacer>
								<v-toolbar-items>
									<v-btn dark text @click="onSaveJobs(desserts)" :disabled="$v.$invalid">Save</v-btn>
								</v-toolbar-items>
							</v-toolbar>
							<div>
								<v-data-table
									:headers="headers"
									:items="desserts"
									:loading="loading"
									loading-text="Loading ..... Please wait"
								>
									<template v-slot:item="props">
										<tr>
											<td :class="{'invalid': $v.desserts.$each[desserts.indexOf(props.item)].QTitle.$error}">
												<v-edit-dialog
													:return-value.sync="props.item.QTitle"
													@save="save"
													@cancel="cancel"
													@open="open"
													@close="close"
												>
													{{ props.item.QTitle }}
													<template v-slot:input>
														<v-text-field
															v-model="props.item.QTitle"
															@input="$v.desserts.$each[desserts.indexOf(props.item)].QTitle.$touch()"
															label="Edit"
															single-line
															counter
														></v-text-field>
														<p v-if="!$v.desserts.$each[desserts.indexOf(props.item)].QTitle.required" class="label-invalid">Required</p>
														<p v-if="!$v.desserts.$each[desserts.indexOf(props.item)].QTitle.maxLength" class="label-invalid">Max Character 200</p>
														<p style="taxt-align: right;">enter to save</p>
													</template>
												</v-edit-dialog>
											</td>
											<td
												class="text-center"
												:class="{'invalid': !$v.desserts.$each[desserts.indexOf(props.item)].QDueDate.isDate}"
											>
												<v-menu
													:ref="`datePicker${desserts.indexOf(props.item)}`"
													v-model="props.item.datePicker"
													:close-on-content-click="false"
													:return-value.sync="props.item.QDueDate"
													transition="scale-transition"
													offset-y
													min-width="290px"
												>
													<template v-slot:activator="{ on }">
														<input
															:value="formatDate(props.item.QDueDate)"
															readonly
															v-on="on"
															:class="{'date-input': true}"
															@input="$v.desserts.$each[desserts.indexOf(props.item)].QDueDate.$touch()"
														/>
													</template>
													<v-date-picker v-model="date" no-title scrollable>
														<v-spacer></v-spacer>
														<v-btn text color="primary" @click="props.item.datePicker = false">Cancel</v-btn>
														<v-btn
															text
															color="primary"
															@click="
                                                        $refs['datePicker' + desserts.indexOf(props.item)].save(date)"
														>OK</v-btn>
													</v-date-picker>
												</v-menu>
											</td>

											<td
												class="text-center"
												:class="{'invalid': !$v.desserts.$each[desserts.indexOf(props.item)].QDueTime.isTime}"
											>
												<v-menu
													:ref="`timePicker${desserts.indexOf(props.item)}`"
													v-model="props.item.timePicker"
													:close-on-content-click="false"
													:nudge-right="40"
													:return-value.sync="props.item.QDueTime"
													transition="scale-transition"
													offset-y
													max-width="290px"
													min-width="290px"
												>
													<template v-slot:activator="{ on }">
														<input
															v-model="props.item.QDueTime"
															readonly
															v-on="on"
															:class="{'time-input': true}"
															@input="$v.desserts.$each[desserts.indexOf(props.item)].QDueTime.$touch()"
														/>
													</template>
													<v-time-picker
														v-if="props.item.timePicker"
														color="grey darken-1"
														v-model="time"
														full-width
														@click:minute="$refs['timePicker' +desserts.indexOf(props.item)].save(time)"
													></v-time-picker>
												</v-menu>
											</td>
											<td :class="{'invalid': $v.desserts.$each[desserts.indexOf(props.item)].QLocation.$error}">
												<v-edit-dialog
													:return-value.sync="props.item.QLocation"
													@save="save"
													@cancel="cancel"
													@open="open"
													@close="close"
												>
													{{ props.item.QLocation }}
													<template v-slot:input>
														<v-text-field
															v-model="props.item.QLocation"
															label="Edit"
															single-line
															counter
															@input="$v.desserts.$each[desserts.indexOf(props.item)].QLocation.$touch()"
														></v-text-field>
														<p v-if="!$v.desserts.$each[desserts.indexOf(props.item)].QLocation.required" class="label-invalid">Required</p>
														<p style="float: right;">enter to save</p>
													</template>
												</v-edit-dialog>
											</td>
											<td class="text-center">
												<Select2
													v-model="props.item.Province"
													:options="['เพชรบุรี', 'กรุงเทพ']"
													:settings="{width: '140px'}"
												></Select2>
											</td>
											<td class="text-center" :class="{'invalid': $v.desserts.$each[desserts.indexOf(props.item)].Postcode.$error}">
												<v-edit-dialog
													:return-value.sync="props.item.Postcode"
													@save="save"
													@cancel="cancel"
													@open="open"
													@close="close"
												>
													{{ props.item.Postcode }}
													<template v-slot:input>
														<v-text-field v-model="props.item.Postcode" label="Edit" single-line counter></v-text-field>
														<p v-if="!$v.desserts.$each[desserts.indexOf(props.item)].Postcode.maxLength" class="label-invalid">Max Character 5</p>
														<p style="float: right;">enter to save</p>
													</template>
												</v-edit-dialog>
											</td>
											<td :class="{'invalid': $v.desserts.$each[desserts.indexOf(props.item)].QDetail.$error}">
												<v-edit-dialog
													:return-value.sync="props.item.QDetail"
													large
													@save="save"
													@cancel="cancel"
													@open="open"
													@close="close"
												>
													<div>{{ props.item.QDetail }}</div>
													<template v-slot:input>
														<div class="mt-4 title">Update QDetail</div>
													</template>
													<template v-slot:input>
														<v-textarea
															v-model="props.item.QDetail"
															label="Edit"
															single-line
															counter
															autofocus
															@input="$v.desserts.$each[desserts.indexOf(props.item)].QDetail.$touch()"
														></v-textarea>
														<p v-if="!$v.desserts.$each[desserts.indexOf(props.item)].QDetail.required" class="label-invalid">Required</p>
													</template>
												</v-edit-dialog>
											</td>
											<td class="text-center">
												<v-simple-checkbox v-model="props.item.InfoStatus" :ripple="false"></v-simple-checkbox>
											</td>
											<td class="text-center">
												<v-icon small @click="deleteItem(props.item)">mdi-delete</v-icon>
											</td>
										</tr>
									</template>
								</v-data-table>

								<v-snackbar v-model="snack" :timeout="3000" :color="snackColor">
									{{ snackText }}
									<template v-slot:action="{ attrs }">
										<v-btn v-bind="attrs" text @click="snack = false">Close</v-btn>
									</template>
								</v-snackbar>
							</div>
						</v-card>
					</v-dialog>
				</v-row>
			</v-app>
		</div>
	</div>
</template>

<script>
import { required, maxLength } from "vuelidate/lib/validators";
import Select2 from "v-select2-component";
import moment from "moment";
const isDate = value => moment(value, "YYYY-MM-DD", true).isValid();
const isTime = value => moment(value, "HH:mm", true).isValid();
export default {
	name: "App",
	components: { Select2 },
	data() {
		return {
			dialogTableJob: false,
			notifications: false,
			sound: true,
			widgets: false,
			files: [],
			loading: false,
			snack: false,
			snackColor: "",
			snackText: "",
			max25chars: v => v.length <= 25 || "Input too long!",
			pagination: {},
			headers: [
				{
					text: "QTitle",
					align: "center",
					value: "QTitle",
					width: "10%",
					class: "grey lighten-4"
				},
				{
					text: "QDueDate",
					value: "QDueDate",
					width: "8%",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "QDueTime",
					value: "QDueTime",
					width: "8%",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "QLocation",
					value: "QLocation",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "Province",
					value: "Province",
					width: "10%",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "Postcode",
					value: "Postcode",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "QDetail",
					value: "QDetail",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "InfoStatus",
					value: "InfoStatus",
					align: "center",
					class: "grey lighten-4"
				},
				{
					text: "Actions",
					value: "actions",
					sortable: false,
					align: "center",
					class: "grey lighten-4"
				}
			],
			desserts: [
				{
					index: 0,
					QTitle: "Frozen Yogurt",
					QDueDate: "ไม่พบข้อมูล",
					QDueTime: "120",
					QLocation: "สยาม",
					Province: "4.0",
					Postcode: "1%",
					QDetail: "Detail",
					InfoStatus: false,
					datePicker: false,
					timePicker: false
				},
				{
					index: 1,
					QTitle: "Worrakarn Palawat",
					QDueDate: "2020-06-01",
					QDueTime: "15:31",
					QLocation: "สยาม",
					Province: "4.0",
					Postcode: "1%",
					QDetail: "Detail",
					InfoStatus: false,
					datePicker: false,
					timePicker: false
				}
			],
			date: new Date().toISOString().substr(0, 10),
			time: null
		};
	},
	validations: {
		desserts: {
			$each: {
				QTitle: { required, maxLength: maxLength(200) },
				QDueDate: {
					isDate(value) {
						return isDate(value);
					}
				},
				QDueTime: {
					isTime(value) {
						return isTime(value);
					}
				},
				QLocation: { required },
				Postcode: { maxLength: maxLength(5) },
				QDetail: { required }
			}
		}
	},
	methods: {
		onFileSelected() {
			if (this.files && this.files.length) this.dialogTableJob = true;
			else this.dialogTableJob = false;
		},
		save() {
			this.snack = true;
			this.snackColor = "success";
			this.snackText = "Data saved";
		},
		cancel() {
			this.snack = true;
			this.snackColor = "error";
			this.snackText = "Canceled";
		},
		open() {
			this.snack = true;
			this.snackColor = "info";
			this.snackText = "Dialog opened";
		},
		close() {
			console.log("Dialog closed");
		},
		deleteItem(item) {
			const index = this.desserts.indexOf(item);
			this.$swal
				.fire({
					title: "Are you sure?",
					text: "You won't be able to revert this!",
					icon: "warning",
					showCancelButton: true,
					confirmButtonColor: "#3085d6",
					cancelButtonColor: "#d33",
					confirmButtonText: "Yes, delete it!"
				})
				.then(result => {
					if (result.value) {
						this.$swal.fire(
							"Deleted!",
							"Your file has been deleted.",
							"success"
						);
						this.desserts.splice(index, 1);
					}
				});
			// confirm("Are you sure you want to delete this item?") &&
			// 	this.desserts.splice(index, 1);
		},
		onSaveJobs(item) {
			console.log(item);
			this.loading = true;

			setTimeout(() => {
				this.loading = false;
				this.dialogTableJob = false;
				this.files = [];
			}, 5000);
		},
		showRef(r) {
			console.log(r);
		},
		formatDate(date) {
			return moment(date).format("DD/MM/YYYY");
		}
	}
};
</script>

<style scoped>
.my-text-style >>> .v-text-field__slot input {
	color: red;
	text-align: center;
	border: 1px solid red;
}
.v-text-field--outlined >>> fieldset {
	border-color: rgb(255, 255, 255);
}

.invalid {
	border: 1px solid #EF5350;
	color: white;
	background-color: #EF5350;
}
.label-invalid {
	color: red;
	text-align: right;
	margin-bottom: 0px;
}
.date-input {
	text-align: center;
	width: 100px;
	outline: none;
}
.time-input {
	text-align: center;
	width: 100px;
	outline: none;
}
p {
	text-align: right;
}
</style>
